/**
 * @license MIT
 * @author Luca Poldelmengo
 * @see {@link https://github.com/pldg/scrollzzz}
 */
"use strict";function addPassiveIfSupported(){var e=!1;try{var t={get passive(){e={passive:!0}}};window.addEventListener("test",null,t),window.removeEventListener("test",null,t)}catch(t){e=!1}return e}function addThrottle(e,t){var r=Date.now();return function(){r+t-Date.now()<0&&(e(),r=Date.now())}}function getCoords(e){var t=window.pageYOffset,r=window.pageXOffset,o=document.body.clientTop||0,n=document.body.clientLeft||0,i=e.getBoundingClientRect(),s=i.top,u=i.left,c=i.height,l=i.width;return{top:s=s+t-o,left:u=u+r-n,height:c,width:l,bottom:s+c,right:u+l}}function isNumber(e){return"number"==typeof e&&!isNaN(parseFloat(e))}function isNonEmptyString(e){return"string"==typeof e&&e.length>0}function scrollzzz(e){var t=e.trigger;void 0===t&&(t=1);var r=e.progress;void 0===r&&(r=!1);var o=e.debug;void 0===o&&(o=!1);var n=e.root;void 0===n&&(n=null);var i,s,u,c,l,a,d=e.targets,f=e.unobserve,p=e.throttle,g=(i=0,s="down",function(){var e=n?n.scrollTop:window.pageYOffset,t=s;return e>i||e===i&&"down"===s?t="down":(e<i||e===i&&"up"===s)&&(t="up"),i=e,s=t,t}),v={},w=[],b=!1,h=!!r&&addPassiveIfSupported(),m=[],y=!0;function z(){return"scrollzzz-trigger--"+("."===d[0]||"#"===d[0]?d.substring(1):d)}function E(e,t){r&&(a=e[0].rootBounds.top),l&&e.forEach((function(e){var o=function(e){var t=e.isIntersecting,r=e.rootBounds.top,o=e.boundingClientRect.top>r;return t?"intersect":!t&&o?"below":"above"}(e),n=e.target,i=parseInt(n.dataset.scrollzzz);l({direction:g(),progress:r?S(e):null,position:o,entry:e}),r&&y&&function(e){var t=function(e){return p?addThrottle(t,p):t;function t(t){l({direction:g(),progress:S(e),position:"intersect",entry:e})}}(e);m.push({addScroll:function(){return window.addEventListener("scroll",t,h)},removeScroll:function(){return window.removeEventListener("scroll",t,h)}})}(e),r&&function(e,t){var r=e.isIntersecting,o=m[t],n=o.addScroll,i=o.removeScroll;r?n():r||y||i()}(e,i),f&&(!function(e,t,r){var o="below"===f&&"below"===e,n="intersect"===f&&"intersect"===e,i="above"===f&&"above"===e;("onLoad"===f||o||n||i)&&r.unobserve(t)}(o,n,t),w.push(i))})),y&&(y=!1)}function S(e){var t=e.target.getBoundingClientRect(),r=t.top,o=1/(t.height/(a-r));return o<0?0:o>1?1:parseFloat(o.toFixed(4))}function x(){throw new Error("scrollzzz has not been initialized")}return v.init=function(){if(b)throw new Error("scrollzzz has beed already initialized");var e;return function(){if(isNonEmptyString(d)||e("targets"),!isNumber(t)||t>1||t<0)throw new Error("trigger must be a number in 0..1 range");if(f){if(!(["onLoad","below","intersect","above"].indexOf(f)>-1))throw new Error('unobserve must be "onLoad" or "below" or "intersect" or "above"');if(r&&"intersecting"===f)throw new Error('if using progress, unobserve can not be "intersect"')}if(!isNumber(p)&&p>0)throw new Error("throttle must be a number > 0");function e(e){throw new Error(e+" must be a valid DOM selector")}n&&!isNonEmptyString(n)&&e("root")}(),isNonEmptyString(n)&&(u=document.querySelector(n)),!0===o&&function(e){var r=document.createElement("div"),o=document.createElement("p");if(r.style.height="0px",r.style.borderTop="2px dashed grey",r.style.zIndex="9999",e){var n=e.getBoundingClientRect(),i=n.height,s=n.width;r.style.position="absolute",r.style.top=t*i+getCoords(e).top+"px",r.style.width=s+"px"}else r.style.position="fixed",r.style.width="100%",r.style.top=100*t+"vh";o.style.fontFamily="monospace",o.style.color="grey",o.style.margin="0",o.style.padding="6px",o.innerText='targets: "'+d+'", trigger: '+t,r.setAttribute("class",z()),r.appendChild(o),document.body.appendChild(r)}(u),c=new IntersectionObserver(E,{rootMargin:(e=100*t,"-"+e+"% 0% -"+(100-e)+"% 0%"),root:u||null}),[].slice.call(document.querySelectorAll(d)).forEach((function(e,t){e.hasAttribute("data-scrollzzz")||e.setAttribute("data-scrollzzz",t),-1===w.indexOf(t)&&c.observe(e)})),b=!0,v},v.observe=function(e){if(b||x(),"function"!=typeof e)throw new Error("observe requires a function");return l=e,v},v.disconnect=function(e){var t;return void 0===e&&(e=!1),b||x(),r&&m.forEach((function(e){return(0,e.removeScroll)()})),!0===o&&(t=document.querySelector("."+z())).parentNode.removeChild(t),e&&w.splice(0),c.disconnect(),b=!1,v},v.update=function(e,i){return void 0===e&&(e={}),void 0===i&&(i=!1),v.disconnect(i),d=e.targets||d,t=e.trigger||t,f=e.unobserve||f,r=e.progress||r,p=e.throttle||p,n=e.root||n,o=e.debug||o,v.init(),v},Object.freeze(v)}module.exports=scrollzzz;
